Index: trunk/src/VBox/VMM/IOM.cpp
===================================================================
--- trunk/src/VBox/VMM/IOM.cpp	(revision 9212)
+++ trunk/src/VBox/VMM/IOM.cpp	(revision 9258)
@@ -1242,5 +1242,5 @@
     PCDBGFINFOHLP pHlp = (PCDBGFINFOHLP)pvUser;
     pHlp->pfnPrintf(pHlp,
-                    "%04x-%04x %VGv %VGv %VGv %VGv %s\n",
+                    "%04x-%04x %VRv %VRv %VRv %VRv %s\n",
                     pRange->Core.Key,
                     pRange->Core.KeyLast,
@@ -1288,8 +1288,8 @@
                     "Range     %.*s %.*s %.*s %.*s Description\n",
                     pVM,
-                    sizeof(RTGCPTR) * 2,      "pDevIns         ",
-                    sizeof(RTGCPTR) * 2,      "In              ",
-                    sizeof(RTGCPTR) * 2,      "Out             ",
-                    sizeof(RTGCPTR) * 2,      "pvUser          ");
+                    sizeof(RTRCPTR) * 2,      "pDevIns         ",
+                    sizeof(RTRCPTR) * 2,      "In              ",
+                    sizeof(RTRCPTR) * 2,      "Out             ",
+                    sizeof(RTRCPTR) * 2,      "pvUser          ");
     RTAvlroIOPortDoWithAll(&pVM->iom.s.pTreesHC->IOPortTreeGC, true, iomR3IOPortInfoOneGC, (void *)pHlp);
 
@@ -1297,5 +1297,5 @@
     {
         PIOMIOPORTRANGEGC pRange = (PIOMIOPORTRANGEGC)MMHyperGC2HC(pVM, pVM->iom.s.pRangeLastReadGC);
-        pHlp->pfnPrintf(pHlp, "GC Read  Ports: %#04x-%#04x %VGv %s\n",
+        pHlp->pfnPrintf(pHlp, "GC Read  Ports: %#04x-%#04x %VRv %s\n",
                         pRange->Port, pRange->Port + pRange->cPorts, pVM->iom.s.pRangeLastReadGC, pRange->pszDesc);
     }
@@ -1303,5 +1303,5 @@
     {
         PIOMIOPORTSTATS pRange = (PIOMIOPORTSTATS)MMHyperGC2HC(pVM, pVM->iom.s.pStatsLastReadGC);
-        pHlp->pfnPrintf(pHlp, "GC Read  Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "GC Read  Stats: %#04x %VRv\n",
                         pRange->Core.Key, pVM->iom.s.pStatsLastReadGC);
     }
@@ -1310,5 +1310,5 @@
     {
         PIOMIOPORTRANGEGC pRange = (PIOMIOPORTRANGEGC)MMHyperGC2HC(pVM, pVM->iom.s.pRangeLastWriteGC);
-        pHlp->pfnPrintf(pHlp, "GC Write Ports: %#04x-%#04x %VGv %s\n",
+        pHlp->pfnPrintf(pHlp, "GC Write Ports: %#04x-%#04x %VRv %s\n",
                         pRange->Port, pRange->Port + pRange->cPorts, pVM->iom.s.pRangeLastWriteGC, pRange->pszDesc);
     }
@@ -1316,5 +1316,5 @@
     {
         PIOMIOPORTSTATS pRange = (PIOMIOPORTSTATS)MMHyperGC2HC(pVM, pVM->iom.s.pStatsLastWriteGC);
-        pHlp->pfnPrintf(pHlp, "GC Write Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "GC Write Stats: %#04x %VRv\n",
                         pRange->Core.Key, pVM->iom.s.pStatsLastWriteGC);
     }
@@ -1323,5 +1323,5 @@
     {
         PIOMIOPORTRANGER3 pRange = pVM->iom.s.pRangeLastReadR3;
-        pHlp->pfnPrintf(pHlp, "HC Read  Ports: %#04x-%#04x %VGv %s\n",
+        pHlp->pfnPrintf(pHlp, "HC Read  Ports: %#04x-%#04x %VHv %s\n",
                         pRange->Port, pRange->Port + pRange->cPorts, pRange, pRange->pszDesc);
     }
@@ -1329,5 +1329,5 @@
     {
         PIOMIOPORTSTATS pRange = pVM->iom.s.pStatsLastReadR3;
-        pHlp->pfnPrintf(pHlp, "HC Read  Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "HC Read  Stats: %#04x %VHv\n",
                         pRange->Core.Key, pRange);
     }
@@ -1336,5 +1336,5 @@
     {
         PIOMIOPORTRANGER3 pRange = pVM->iom.s.pRangeLastWriteR3;
-        pHlp->pfnPrintf(pHlp, "HC Write Ports: %#04x-%#04x %VGv %s\n",
+        pHlp->pfnPrintf(pHlp, "HC Write Ports: %#04x-%#04x %VHv %s\n",
                         pRange->Port, pRange->Port + pRange->cPorts, pRange, pRange->pszDesc);
     }
@@ -1342,5 +1342,5 @@
     {
         PIOMIOPORTSTATS pRange = pVM->iom.s.pStatsLastWriteR3;
-        pHlp->pfnPrintf(pHlp, "HC Write Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "HC Write Stats: %#04x %VHv\n",
                         pRange->Core.Key, pRange);
     }
@@ -1349,5 +1349,5 @@
     {
         PIOMIOPORTRANGER0 pRange = (PIOMIOPORTRANGER0)MMHyperR0ToCC(pVM, pVM->iom.s.pRangeLastReadR0);
-        pHlp->pfnPrintf(pHlp, "R0 Read  Ports: %#04x-%#04x %VGv %s\n",
+        pHlp->pfnPrintf(pHlp, "R0 Read  Ports: %#04x-%#04x %VHv %s\n",
                         pRange->Port, pRange->Port + pRange->cPorts, pRange, pRange->pszDesc);
     }
@@ -1355,5 +1355,5 @@
     {
         PIOMIOPORTSTATS pRange = (PIOMIOPORTSTATS)MMHyperR0ToCC(pVM, pVM->iom.s.pStatsLastReadR0);
-        pHlp->pfnPrintf(pHlp, "R0 Read  Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "R0 Read  Stats: %#04x %VHv\n",
                         pRange->Core.Key, pRange);
     }
@@ -1368,5 +1368,5 @@
     {
         PIOMIOPORTSTATS pRange = (PIOMIOPORTSTATS)MMHyperR0ToCC(pVM, pVM->iom.s.pStatsLastWriteR0);
-        pHlp->pfnPrintf(pHlp, "R0 Write Stats: %#04x %VGv\n",
+        pHlp->pfnPrintf(pHlp, "R0 Write Stats: %#04x %VHv\n",
                         pRange->Core.Key, pRange);
     }
@@ -1685,5 +1685,5 @@
                     pRange->pvUserR0);
     pHlp->pfnPrintf(pHlp,
-                    "%*s %VGv %VGv %VGv %VGv %VGv\n",
+                    "%*s %VRv %VRv %VRv %VRv %VRv\n",
                     sizeof(RTGCPHYS) * 2 * 2 + 1, "GC",
                     pRange->pDevInsGC,